
/**
 * jQuery Theme Switcher plugin
 *
 * Copyright (c) 2011 Dave Hoff (davehoff.com)
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 *
 */


(function( $ ){

	$.fn.themeswitcher = function( options ) {

		var switcherDiv = this, switcherOptions = {};
		var settings = {
			loadtheme : "new-blue",
			//height: 100,
			width: 644,
			rounded: true,
			imgpath: "https://www.smart-rechner.de/widgets/pics/themeswitcher/",
			//themepath:"https://www.smart-rechner.de/widgets/themes/",
			themepath:"https://www.smart-rechner.de/widgets/hotlink-ok/themes_1.11.4/",
			//jqueryuiversion: "1.8.10",
			jqueryuiversion: "1.11.4",
			initialtext: "Design auswählen",
			buttonpretext: "",
			buttonposttext: "",   // NEU: Um auch ein schließendes Tag einfügen zu können

			// Siehe unten bei changesnippet
			//changesnippet: false, // NEU: Auf Konfigurator_Basis_Widget wird Snippettext mit 'theme' gesetzt
			extrabreit:false,

			closeonselect: true,
			buttonheight: 42,
			themes: [],
			additionalthemes: [],
			onopen: null,
			onclose: null,
			onselect: null,
			// NEU: Der an den Head zu hängende neue UI-Style soll einen Klassennamen erhalten,
			// damit genau dieser link-Tag beim nächsten Wechsel ersetzt werden kann.
			// styleclass: "jquery-ui-switcher-styleclass"
			styleclass: "",
			// NEU: Die Id wird vor die farberhaltenden Style-Rules gesetzt, die per style-Tag eingehangen werden
			styleid: "",
			// NEU: Widgetname, um den CSS-Dateinamen damit zusammenzusetzen
			widget: ""
    	};

    	if(options) {
	    	//lowercase all options passed in
	    	$.each(options, function(k,v){
	    		switcherOptions[k.toLowerCase()] = v;
	    	});

			$.extend( settings, switcherOptions );
    	}

    	

    	if( ! settings.themes.length ){
    		var themes = [

				    			{
    				title: "New-Blue",
    				name: "new-blue",
    				icon: "theme_90_new_blue.png"
    			},
    			
				{
					title: "Aristo",
					name: "aristo",
					icon: "theme_90_aristo.png"
				},
    			{
    				title: "Blitzer",
    				name: "blitzer",
    				icon: "theme_90_blitzer.png"
    			},
				{
    				title: "Leather",
    				name: "leather",
    				icon: "theme_90_leather.png"
    			},
    			{
    				title: "Bootstrap",
    				name: "bootstrap",
    				icon: "theme_90_bootstrap.png"
    			},
				{
					title: "Petrol",
					name: "petrol",
					icon: "theme_90_petrol.png"
				},
				{
					title: "Magenta",
					name: "magenta",
					icon: "theme_90_magenta.png"
				},
     			{
    				title: "Yellue",
    				name: "yellue",
    				icon: "theme_90_yellue.png"
    			},
				{
					title: "Red-Spring",
					name: "red-spring",
					icon: "theme_90_red_spring.png"
				},
				{
					title: "Polar",
					name: "polar",
					icon: "theme_90_polar.png"
				},
				{
					title: "Delta",
					name: "delta",
					icon: "theme_90_delta.png"
				},
    			{
    				title: "Snow",
    				name: "snow",
    				icon: "theme_90_snow.png"
    			},
    			{
    				title: "Bluerange",
    				name: "bluerange",
    				icon: "theme_90_bluerange.png"
    			},
				{
				   title: "Opensans-Blue",
				   name: "opensans-blue",
				   icon: "theme_90_opensans_blue.png"
			   },
								  {
				  title: "Standard",
				  name: "standard",
				  icon: "theme_90_standard.png"
			  },
			      			{
    				title: "Black Tie",
    				name: "black-tie",
    				icon: "theme_90_black_tie.png"
    			},
    			{
    				title: "Cupertino",
    				name: "cupertino",
    				icon: "theme_90_cupertino.png"
    			},
				{
					 title: "Helvarial-Blue",
					 name: "helvarial-blue",
					 icon: "theme_90_helvarial_blue.png"
				},
    			{
    				title: "Dark Hive",
    				name: "dark-hive",
    				icon: "theme_90_dark_hive.png"
    			},
    			{
    				title: "Dot Luv",
    				name: "dot-luv",
    				icon: "theme_90_dot_luv.png"
    			},
    			{
    				title: "Eggplant",
    				name: "eggplant",
    				icon: "theme_90_eggplant.png"
    			},
    			{
    				title: "Excite Bike",
    				name: "excite-bike",
    				icon: "theme_90_excite_bike.png"
    			},
    			{
    				title: "Flick",
    				name: "flick",
    				icon: "theme_90_flick.png"
    			},
				{
					title: "Green Orange",
					name: "green-orange",
					icon: "theme_90_green_orange.png"
				},
    			{
    				title: "Green Petrol",
    				name: "green-petrol",
    				icon: "theme_90_green_petrol.png"
    			},
    			{
    				title: "Hot Sneaks",
    				name: "hot-sneaks",
    				icon: "theme_90_hot_sneaks.png"
    			},
    			{
    				title: "Humanity",
    				name: "humanity",
    				icon: "theme_90_humanity.png"
    			},
    			{
    				title: "Le Frog",
    				name: "le-frog",
    				icon: "theme_90_le_frog.png"
    			},
    			{
    				title: "Mint Choc",
    				name: "mint-choc",
    				icon: "theme_90_mint_choco.png"
    			},
    			{
    				title: "Overcast",
    				name: "overcast",
    				icon: "theme_90_overcast.png"
    			},
    			{
    				title: "Pepper Grinder",
    				name: "pepper-grinder",
    				icon: "theme_90_pepper_grinder.png"
    			},
    			{
    				title: "Raiff",
    				name: "raiff",
    				icon: "theme_90_raiff.png"
    			},
    			{
    				title: "Redmond",
    				name: "redmond",
    				icon: "theme_90_windoze.png"
    			},
    			{
    				title: "Smoothness",
    				name: "smoothness",
    				icon: "theme_90_smoothness.png"
    			},
    			{
    				title: "South Street",
    				name: "south-street",
    				icon: "theme_90_south_street.png"
    			},
    			{
    				title: "Start",
    				name: "start",
    				icon: "theme_90_start_menu.png"
    			},
    			{
    				title: "Sunny",
    				name: "sunny",
    				icon: "theme_90_sunny.png"
    			},
    			{
    				title: "Swanky Purse",
    				name: "swanky-purse",
    				icon: "theme_90_swanky_purse.png"
    			},
    			{
    				title: "Trontastic",
    				name: "trontastic",
    				icon: "theme_90_trontastic.png"
    			},
    			{
    				title: "UI Darkness",
    				name: "ui-darkness",
    				icon: "theme_90_ui_dark.png"
    			},
    			{
    				title: "UI Lightness",
    				name: "ui-lightness",
    				icon: "theme_90_ui_light.png"
    			},
    			{
    				title: "Vader",
    				name: "vader",
    				icon: "theme_90_black_matte.png"
    			},

    			    		];
    	}else{
    		var themes = settings.themes;
    	}

    	if( settings.additionalthemes.length ){
    		$.extend( themes, settings.additionalthemes );
    	}

    	// Switcher link
    	var switcherLinkStyle = {
			"position":"relative",
    		"cursor": "pointer",
    		"font-family": "'Helvetica Neue', Helvetica, Arial, sans-serif",
    		"font-size": "1em",
    		"font-weight": "normal",
    		"color": "#333",
			//"background-color": "#f5f6fa",
    		//"border":"1px solid #d0d1e9",

			"background-color": "rgba(80, 120, 160, 0.065)",
    		"border":"1px solid rgba(80, 120, 160, 0.15)",

    		"text-decoration": "none",
    		"padding":"0px 15px",
    		"width": settings.width+"px",
    		"display": "block",
    		"height": settings.buttonheight+"px",
    		"outline": "0px" ,
    		"line-height": settings.buttonheight+"px"
    	};

    	if( settings.rounded ){
    		switcherLinkStyle['border-radius'] = "4px";
    		switcherLinkStyle['-moz-border-radius'] = "4px";
    		switcherLinkStyle['-webkit-border-radius'] = "4px";
    	}


    	// Switcher Link anlegen
    	var switcherLink = $("<a></a>")
    		.addClass("jquery-ui-switcher-link")
    		.css(switcherLinkStyle);


    	// Title and Icon for switcher link
    	var switcherTitle = $("<span></span>")
    		.css({"line-height":""+settings.buttonheight+"px"})
    		.addClass("jquery-ui-switcher-title").appendTo(switcherLink);
    	var switcherArrow = $("<div></div>").addClass("jquery-ui-switcher-arrow")
    		.css({
    			"position":"absolute",
    			"top":"50%",
    			"margin-top": "-8px",
    			"right":"15px",
    			"width": "16px",
    			"height": "16px",
    			"background": "url("+settings.imgpath+"show.png) no-repeat 50% 50%",
    			"opacity":"0.5",
				"filter":"alpha(opacity=50)" /* For IE8 and earlier */
    		})
    		.appendTo(switcherLink);

    	// load the default theme
    	if( settings.loadtheme.length ){
    		switcherTitle.html(settings.buttonpretext +" "+ findTheme(settings.loadtheme).title+" "+settings.buttonposttext);
		}
    	else {
			switcherTitle.html(settings.initialtext);
		}


    	// Events an Switcher Link binden
 		switcherLink.bind({
    		mouseover: function(){
    			$(this).css({
    				"background": "#e5e6ea"
    			});
    			switcherTitle.css({
    				"color":"black"
    			});
    			switcherArrow.css({
    				"opacity":"1",
					"filter":"alpha(opacity=100)" // For IE8 and earlier
				});
    		},
    		mouseleave: function(){
    			if( ! switcherDiv.find(".jquery-ui-switcher-list-hldr").is(":visible") ){
    				$(this).css({
     					"background-color": "#f5f6fa"
    				});
	    			switcherTitle.css("color", switcherLinkStyle.color);
	    			switcherArrow.css({
	    				"opacity":"0.5",
						"filter":"alpha(opacity=50)" // For IE8 and earlier
					});
    			}
    		},

    		click: function(){
 				if (!switcherDiv.find(".jquery-ui-switcher-list-hldr").is(":visible")) {
 					openSwitcher();
 				}
 				else {
 					closeSwitcher();
 					$(this).mouseover(); // Damit switcherLink nach Klick zum Schließen, aktiv bleibt, ohne die Maus bewegen zu müssen
 				}
    		}
    	});


    	var switcherListHldr = $("<div></div>")
    		.addClass("jquery-ui-switcher-list-hldr")
    		.css({
    			"width": eval(settings.width-24)+"px",
    			"background": "#000",
    			"color": "#FFF",
    			"font-family": "Arial, Verdana, sans-serif",
    			"font-size": "12px",
    			"border": "5px solid #000",
    			"border-top": "none",
    			"z-index": "999999",
    			"position": "absolute",
    			"top": eval(settings.buttonheight+2)+"px",
    			"left": "21px",
    			"padding": "3px 3px 3px 0px",
   			"overflow-x": "scroll",
    			"display": "none",
    			"overflow-x": "scroll"
    		});

    		if (settings.extrabreit) {
    			switcherListHldr.css({
    				"width": eval(parseInt(settings.width)+16)+"px",
    				"left": "1px"
    			});
    		}

    		if (settings.rounded) {
    			switcherListHldr.css("border-radius","0 0 5px 5px");
    			switcherListHldr.css("-moz-border-radius","0 0 5px 5px");
    			switcherListHldr.css("-webkit-border-radius","0 0 5px 5px");
    		}

//switcherListHldr.perfectScrollbar();

    	var switcherList = $("<ul></ul>")
    		.css({
    			"list-style": "none",
    			"margin": "0",
    			"padding": "0",
    			// Breite eines <a></a> mal Anzahl der Themes
    			"width": eval(110 * themes.length)+"px"
    		})
    		.appendTo(switcherListHldr);

    	// Iterate over themes and build links
    	$.each(themes, function(k,v){
    		var listItem = $("<li></li>")
    			.css({
    			    "float":"left",
    				"margin":"0",
    				"padding":"0",
    				"background-image":"none"
    			})
    			.appendTo(switcherList);

    		var listLink = $("<a></a>")
    			.css({
    				"line-height":"0em",
    				"display": "block",
    				"padding": "5px 10px 5px 10px",
    				"margin-bottom":"5px",
					"text-decoration": "none",
					"width": "90px",
					"height":"90px"
    			})
    			.bind({
    				mouseenter: function(){
    					listLink.css("background","url("+settings.imgpath+"menuhoverbg.png) repeat-x 50% 50%");
    				},
    				mouseleave: function(){
    					listLink.css("background","none");
    				},
    				click: function(e){
    					updateTheme($(this).data());
    					e.preventDefault();
    				}
    			})
    			.attr("href","#")
    			.data(v)
    			.appendTo(listItem);

    		var linkImg = $("<img>")
    			.attr("src", settings.imgpath + v.icon)
    			.attr("title",v.title)
    			.css({
    				"margin": "0px",
    				"padding": "0px",
    				"border": "1px solid #333"
    			})
    			.appendTo(listLink);

    		var linkText = $("<span></span>")
    			.css({
    				"display":"block",
    				"line-height":"1em",
    				"margin-top": "0px",
    				"margin": "0px",
    				"padding": "0px",
    				"color": "#AAA"
    			})
    			.text(v.title)
    			.appendTo(listLink);
    	});


    	function updateTheme(data)
    	{
    		if( settings.onselect !== null ) {
    			settings.onselect(settings, data);
    		}

    		switcherTitle.html(settings.buttonpretext +" "+ data.title +" "+settings.butttonposttext);

			changeHead(settings, data);

			// In Snippet-Text ThemeVariable ändern.(nur für Basic-Konfigurator notwendig, der aber momentan keinen Theme-Switcher zur Verfügung stellt.
			// Falls er dort wieder eingeschaltet wird, sollte noch das Setting 'changesnippet' insofern geändert werden, als dass stattdessen mit 'onselect'
			// das Snippet geändert wird. z.B. wie in Premium-Konfigurator changeHiddenWidgetParam(data) definiert wurde...
			//if (settings.changesnippet) {
			//	var snippetText = $("textarea").val();
			//	snippetText = snippetText.replace(/theme = "[\w-]+"/, 'theme = "'+data.name+'"');
			//	$("textarea").val(snippetText);
			//}

    		switcherDiv.find(".jquery-ui-switcher-title").html(settings.buttonpretext + " " + data.title + " " + settings.buttonposttext);

    		if( settings.closeonselect ) {
    			closeSwitcher();
    		}
    	}




    	// Finds a theme[] based on a valid name or title
    	function findTheme(theme){
    		var result = null;
    		$.each(themes, function(k,v){
    			if( v.name.toLowerCase() === theme.toLowerCase() || v.title.toLowerCase() === theme.toLowerCase() ){
    				result = v;
    				return false;
    			}
    		});

    		if( !result ){
    			return themes[0];
    		}
    		return result;
    	}

    	function openSwitcher(){
    		if( settings.onopen !== null )
    			settings.onopen();

    		switcherArrow.css({
    			"background": "url("+settings.imgpath+"hide.png) no-repeat 50% 50%"
			});

    		// Beim Sliden geht leider der Scrollbalken verloren
    		//switcherDiv.find(".jquery-ui-switcher-list-hldr").slideDown("slow"); //fadeIn("slow"); //slideDown("slow");
    		switcherDiv.find(".jquery-ui-switcher-list-hldr").slideDown("slow", function() {
//$(this).perfectScrollbar('update');
    		});

    	}

    	function closeSwitcher(){
    		if( settings.onclose !== null )
    			settings.onclose();

    		switcherTitle.css("color", switcherLinkStyle.color);
 			switcherArrow.css({
    			"background": "url("+settings.imgpath+"show.png) no-repeat 50% 50%",
	    		"opacity":"0.5",
				"filter":"alpha(opacity=50)" // For IE8 and earlier
			});

    		switcherDiv.find(".jquery-ui-switcher-list-hldr").slideUp("slow");//.fadeOut();
    		switcherDiv.find(".jquery-ui-switcher-link")
    					.css({
    		    			"color":"inherit",
   							"background-color":"#f5f6fa"
    		    		});

    	}

    	this.css("position","relative");
    	this.append(switcherLink);
    	this.append(switcherListHldr);

    	$(document).click(function(e) {
    		var $target = $(e.target);
			var switcherDivId = '#' + switcherDiv.attr("id");

    	    if (! ($target.parents().addBack().is(switcherDivId)) ) {
    			closeSwitcher();
    		}
		});

    	return this;
    };




	function changeHead(settings, data)
	{
		// In Demo hatte Zuweisung des richtigen Styles nicht funktioniert, weil Widget-Name nicht bekannt war.
		// Daher wird nun globale Variabe actualWidgetInDemo in tpl_inc_scripts für Demoseite gesetzt
		if (typeof(actualWidgetInDemo)!="undefined")
		{
			settings.widget = actualWidgetInDemo;
		}


		// Hier den Original-LINK-Tag ermitteln und durch neuen ersetzen
		// Dabei spezielles Stylesheet genau für dieses Theme und dieses Widget aufrufen
		var currentStyle = $('link.' + settings.styleclass);
		if (currentStyle.attr("href").indexOf("jquery-ui-allwidgets")!=-1)
		{
			currentStyle.attr("href", settings.themepath+data.name+"/jquery-ui-allwidgets_sc.css");
		}
		else
		{
			 currentStyle.attr("href", settings.themepath+data.name+"/jquery-ui-"+settings.widget+".css");
		}

		// Da ansonsten zum Teil falsche Farben von aufrufender Seite geerbt würden, hier richtige Farben für neuen Style
		// festlegen. Diese werden stets im nächsten STYLE-Tag festgelegt. Den vorhandenen also löschen und den neuen anhängen.
		

var themes = {

	// SB: PRELOAD
	// Rechner auf smart-rechner.de erhalten kein Theme, also keinen eigenen CSS-Aufruf im Rechner, sondern aus Performancegründen bereits vorher hart codiert im Head
	//'none':			{ name : "none", fcHeader : "", fcContent : "", fcDefault : "", fcActive : "", fcHover : "", fcHighlight: "", fcError : "" },


	// jquery UI Themes
	'black-tie':		{ name : "black-tie", 	fcHeader : "#eeeeee", fcContent : "#222222", fcDefault : "#e3e3e3", fcActive : "#222222", fcHover : "#ffffff", fcHighlight: "#363636", fcError : "#ffffff" },
	'blitzer':			{ name : "blitzer",		fcHeader : "#ffffff", fcContent : "#333333", fcDefault : "#004276", fcActive : "#cc0000", fcHover : "#111111", fcHighlight: "#444444", fcError : "#2e2e2e" },
	'cupertino':		{ name : "cupertino",	fcHeader : "#222222", fcContent : "#362b36", fcDefault : "#2779aa", fcActive : "#ffffff", fcHover : "#0070a3", fcHighlight: "#363636", fcError : "#ffffff" },
	'dark-hive':		{ name : "dark-hive",	fcHeader : "#ffffff", fcContent : "#ffffff", fcDefault : "#eeeeee", fcActive : "#ffffff", fcHover : "#ffffff", fcHighlight: "#2e7db2", fcError : "#111111" },
	'dot-luv':			{ name : "dot-luv",		fcHeader : "#f6f6f6", fcContent : "#d9d9d9", fcDefault : "#ffffff", fcActive : "#75abff", fcHover : "#ffffff", fcHighlight: "#ffffff", fcError : "#ffffff" },
	'eggplant':			{ name : "eggplant",		fcHeader : "#ffffff", fcContent : "#ffffff", fcDefault : "#665874", fcActive : "#ffffff", fcHover : "#734d99", fcHighlight: "#333333", fcError : "#ffffff" },
	'excite-bike':		{ name : "excite-bike",	fcHeader : "#e69700", fcContent : "#222222", fcDefault : "#ffffff", fcActive : "#ffffff", fcHover : "#ffffff", fcHighlight: "#333333", fcError : "#ffffff" },
	'flick':				{ name : "flick",			fcHeader : "#444444", fcContent : "#444444", fcDefault : "#0073ea", fcActive : "#ff0084", fcHover : "#ffffff", fcHighlight: "#444444", fcError : "#222222" },
	'hot-sneaks':		{ name : "hot-sneaks",	fcHeader : "#e1e463", fcContent : "#2c4359", fcDefault : "#333333", fcActive : "#ffffff", fcHover : "#212121", fcHighlight: "#363636", fcError : "#ffffff" },
	'humanity':			{ name : "humanity",		fcHeader : "#ffffff", fcContent : "#1e1b1d", fcDefault : "#3f3731", fcActive : "#b85700", fcHover : "#a46313", fcHighlight: "#060200", fcError : "#592003" },
	'le-frog':			{ name : "le-frog",		fcHeader : "#ffffff", fcContent : "#ffffff", fcDefault : "#ffffff", fcActive : "#ffffff", fcHover : "#ffffff", fcHighlight: "#363636", fcError : "#2b2b2b" },
	'mint-choc':		{ name : "mint-choc",	fcHeader : "#e3ddc9", fcContent : "#ffffff", fcDefault : "#9bcc60", fcActive : "#e3ddc9", fcHover : "#baec7e", fcHighlight: "#ffffff", fcError : "#ffffff" },
	'overcast':			{ name : "overcast",		fcHeader : "#444444", fcContent : "#333333", fcDefault : "#3383bb", fcActive : "#ffffff", fcHover : "#599fcf", fcHighlight: "#444444", fcError : "#ffffff" },
	'pepper-grinder':	{ name : "pepper-grinder",	fcHeader : "#453821", fcContent : "#1f1f1f", fcDefault : "#654b24", fcActive : "#140f06", fcHover : "#ffffff", fcHighlight: "#3a3427", fcError : "#ffffff" },
	'redmond':			{ name : "redmond",		fcHeader : "#ffffff", fcContent : "#222222", fcDefault : "#2e6e9e", fcActive : "#e17009", fcHover : "#1d5987", fcHighlight: "#363636", fcError : "#cd0a0a" },
	'smoothness':		{ name : "smoothness",	fcHeader : "#222222", fcContent : "#222222", fcDefault : "#555555", fcActive : "#212121", fcHover : "#212121", fcHighlight: "#363636", fcError : "#cd0a0a" },
	'south-street':	{ name : "south-street",fcHeader : "#433f38", fcContent : "#312e25", fcDefault : "#ffffff", fcActive : "#459e00", fcHover : "#ffffff", fcHighlight: "#363636", fcError : "#cd5c0a" },
	'start':				{ name : "start",			fcHeader : "#eaf5f7", fcContent : "#222222", fcDefault : "#ffffff", fcActive : "#ffffff", fcHover : "#026890", fcHighlight: "#915608", fcError : "#ffffff" },
	'sunny':				{ name : "sunny",			fcHeader : "#ffffff", fcContent : "#383838", fcDefault : "#4c3000", fcActive : "#0074c7", fcHover : "#381f00", fcHighlight: "#1f1f1f", fcError : "#ffffff" },
	'swanky-purse':	{ name : "swanky-purse",fcHeader : "#eacd86", fcContent : "#efec9f", fcDefault : "#f8eec9", fcActive : "#f9f2bd", fcHover : "#f8eec9", fcHighlight: "#060200", fcError : "#803f1e" },
	'trontastic':		{ name : "trontastic",	fcHeader : "#222222", fcContent : "#ffffff", fcDefault : "#b8ec79", fcActive : "#ffffff", fcHover : "#96f226", fcHighlight: "#030303", fcError : "#74736d" },
	'ui-darkness':		{ name : "ui-darkness",	fcHeader : "#ffffff", fcContent : "#ffffff", fcDefault : "#eeeeee", fcActive : "#ffffff", fcHover : "#ffffff", fcHighlight: "#2e7db2", fcError : "#111111" },
	'ui-lightness':	{ name : "ui-lightness",fcHeader : "#ffffff", fcContent : "#333333", fcDefault : "#1c94c4", fcActive : "#eb8f00", fcHover : "#c77405", fcHighlight: "#363636", fcError : "#ffffff" },
	'vader':				{ name : "vader",			fcHeader : "#ffffff", fcContent : "#eeeeee", fcDefault : "#333333", fcActive : "#ffffff", fcHover : "#000000", fcHighlight: "#cccccc", fcError : "#cd0a0a" },


	// Eigene Themes
	'kapital-rechner':{ name : "kapital-rechner",fcHeader : "#ffffff", fcContent : "#222222", fcDefault : "#2b7bd0", fcActive : "#fc9928", fcHover : "#1b6bc0", fcHighlight: "#363636", fcError : "#cd0a0a" },
	'medizin-rechner':{ name : "medizin-rechner",fcHeader : "#ffffff", fcContent : "#222222", fcDefault : "#2b7bd0", fcActive : "#fc9928", fcHover : "#1b6bc0", fcHighlight: "#363636", fcError : "#cd0a0a" },
	'standard':	      { name : "standard",			fcHeader : "#ffffff", fcContent : "#222222", fcDefault : "#2b7bd0", fcActive : "#fc9928", fcHover : "#1b6bc0", fcHighlight: "#363636", fcError : "#cd0a0a" },
	'aristo':			{ name : "aristo",			fcHeader : "#4F4F4F", fcContent : "#4F4F4F", fcDefault : "#4F4F4F", fcActive : "#313131", fcHover : "#313131", fcHighlight: "#0d2054", fcError : "#cd0a0a" },
	'snow':				{ name : "snow",				fcHeader : "#000000", fcContent : "#000000", fcDefault : "#555555", fcActive : "#212121", fcHover : "#212121", fcHighlight: "#363636", fcError : "#cd0a0a" },
	'polar':				{ name : "polar",				fcHeader : "#ffffff", fcContent : "#222222", fcDefault : "#333333", fcActive : "#212121", fcHover : "#212121", fcHighlight: "#363636", fcError : "#cd0a0a" },
	'delta':				{ name : "delta",				fcHeader : "#1b1d1f", fcContent : "#222222", fcDefault : "#222222", fcActive : "#ffffff", fcHover : "#212121", fcHighlight: "#363636", fcError : "#cd0a0a" },
	'bootstrap':		{ name : "bootstrap",		fcHeader : "#ffffff", fcContent : "#404040", fcDefault : "#333333", fcActive : "#ffffff", fcHover : "#212121", fcHighlight: "#404040", fcError : "#ffffff" },			//fcHeader vorher #222222
	'yellue':			{ name : "yellue",			fcHeader : "#5d5d5c", fcContent : "#5d5d5c", fcDefault : "#ffffff", fcActive : "#4d4d4c", fcHover : "#ffffff", fcHighlight: "#4d4d4c", fcError : "#cd0a0a" },
	'opensans-blue':	{ name : "opensans-blue",	fcHeader : "#ffffff", fcContent : "#333333", fcDefault : "#3d6da4", fcActive : "#eca830", fcHover : "#2d5d94", fcHighlight: "#3d6da4", fcError : "#cd0a0a" },
	'helvarial-blue':	{ name : "helvarial-blue",	fcHeader : "#ffffff", fcContent : "#333333", fcDefault : "#3d6da4", fcActive : "#eca830", fcHover : "#2d5d94", fcHighlight: "#3d6da4", fcError : "#cd0a0a" },
	'new-blue':			{ name : "new-blue",			fcHeader : "#ffffff", fcContent : "#333333", fcDefault : "#333333", fcActive : "#ffffff", fcHover : "#2f5880", fcHighlight: "#333333", fcError : "#db3811" },
	'red-spring':		{ name : "red-spring",		fcHeader : "#ffffff", fcContent : "#333333", fcDefault : "#333333", fcActive : "#ffffff", fcHover : "#bb0000", fcHighlight: "#333333", fcError : "#cc0000" },


	// Kunden-Themes
	'erzbistum-koeln':{ name : "erzbistum-koeln",fcHeader : "#ffffff", fcContent : "#333333", fcDefault : "#0c2a70", fcActive : "#beaa41", fcHover : "#ffffff", fcHighlight: "#111111", fcError : "#2e2e2e" },
	'flat-blue':		{ name : "flat-blue",		fcHeader : "#ffffff", fcContent : "#000000", fcDefault : "#ffffff", fcActive : "#000000", fcHover : "#ffffff", fcHighlight: "#000000", fcError : "#cd0a0a" },
	'flat-green':		{ name : "flat-green",		fcHeader : "#ffffff", fcContent : "#000000", fcDefault : "#ffffff", fcActive : "#000000", fcHover : "#ffffff", fcHighlight: "#000000", fcError : "#cd0a0a" },
	'cust-qs':			{ name : "cust-qs",			fcHeader : "#ffffff", fcContent : "#333333", fcDefault : "#ffffff", fcActive : "#333333", fcHover : "#ffffff", fcHighlight: "#333333", fcError : "#2e2e2e" },
	'cust-tm':			{ name : "cust-tm",			fcHeader : "#ffffff", fcContent : "#333333", fcDefault : "#ffffff", fcActive : "#333333", fcHover : "#ffffff", fcHighlight: "#333333", fcError : "#2e2e2e" },
	'cust-kkh':			{ name : "cust-kkh",			fcHeader : "#ffffff", fcContent : "#222222", fcDefault : "#1a3276", fcActive : "#d07738", fcHover : "#0a2266", fcHighlight: "#363636", fcError : "#cd0a0a" },
	// BKK R+V
	'raiff':				{ name : "raiff",				fcHeader : "#ffffff", fcContent : "#00294D", fcDefault : "#ffffff", fcActive : "#ffffff", fcHover : "#ffffff", fcHighlight: "#ffffff", fcError : "#cd0a0a" },
	// *** stellenanzeigen.de
	'green-petrol':	{ name : "green-petrol",	fcHeader : "#ffffff", fcContent : "#444444", fcDefault : "#ffffff", fcActive : "#ffffff", fcHover : "#ffffff", fcHighlight: "#333333", fcError : "#333333" },
	// *** anwalt.de
	'bluerange':		{ name : "bluerange",		fcHeader : "#333333", fcContent : "#333333", fcDefault : "#333333", fcActive : "#ffffff", fcHover : "#284263", fcHighlight: "#385273", fcError : "#990000" },
	// *** Diro
	'leather':			{ name : "leather",			fcHeader : "#707070", fcContent : "#707070", fcDefault : "#707070", fcActive : "#ffffff", fcHover : "#707070", fcHighlight: "#707070", fcError : "#990000" },
	// *** HSP
	'green-orange':	{ name : "green-orange",	fcHeader : "#ffffff", fcContent : "#333333", fcDefault : "#006600", fcActive : "#ffffff", fcHover : "#004400", fcHighlight: "#006600", fcError : "#cd0a0a" },
	// *** Telekom
	'magenta':			{ name : "magenta",			fcHeader : "#171B26", fcContent : "#171B26", fcDefault : "#171B26", fcActive : "#ffffff", fcHover : "#171B26", fcHighlight: "#171B26", fcError : "#ee3f54" },
	// *** DATEV
	'petrol':			{ name : "petrol",			fcHeader : "#039a9a", fcContent : "#0f0f0f", fcDefault : "#0f0f0f", fcActive : "#ffffff", fcHover : "#0f0f0f", fcHighlight: "#0f0f0f", fcError : "#ea0000" }
};



function getAdditionalColorRules(themeColors, wrapper_id)
{
	/****** Ermittele korrekte Farben und sorge für deren korrekte    ******/
    /****** Vererbung an alle entsprechenden Widget-Elemente,         ******/
    /****** statt sie versehentlich vom Hauptdokument zu erben.       ******/
    /****** 												          ******/
    /****** Weitere Regeln hier für tiefere Verschachtelungen, die    ******/
    /****** durch ui-css nicht abgedeckt werden.                      ******/


	var rules = '';


    //***** TEXTFARBE CONTENT *****//
    rules += wrapper_id + '.ui-mytooltip .ui-mytooltip-content,';
	rules += wrapper_id + '.ui-mytooltip .ui-mytooltip-content h1,';
	rules += wrapper_id + '.ui-mytooltip .ui-mytooltip-content h2,';
	rules += wrapper_id + '.ui-mytooltip .ui-mytooltip-content p,';
	rules += wrapper_id + '.ui-mytooltip .ui-mytooltip-content span,';
	rules += wrapper_id + '.ui-mytooltip .ui-mytooltip-content caption,';
	rules += wrapper_id + '.ui-myresult,';
	rules += wrapper_id + '.ui-myresult table caption,';
	//	rules += wrapper_id + '.ui-myresult *,';  				// Nicht *, weil für <span class="ui-button"></span> andere Farben benötigt werden
	rules += wrapper_id + '.ui-myresult div,';
	rules += wrapper_id + '.ui-myresult td,';
	rules += wrapper_id + '.ui-myresult p,';
	//rules += wrapper_id + '.ui-myresult span,';				// SPAN also nicht, weil für Ad-Button Originalfarben benötigt werden
	rules += wrapper_id + 'table td,';
	rules += wrapper_id + 'fieldset,';
	rules += wrapper_id + 'fieldset .ui-myresult h1,';
	rules += wrapper_id + 'fieldset .ui-myresult h2,';
	rules += wrapper_id + 'fieldset .ui-myresult p,';
	rules += wrapper_id + 'fieldset .ui-myresult span:not(.ui-button-text),';
	rules += wrapper_id + 'label,';
    rules += wrapper_id + '.ui-widget-content a,';							// Für Link Leistungsbeschreibung
	rules += wrapper_id + '.ui-datepicker-calendar th span,';				// Überschrift der Tage im Datepicker
    rules += wrapper_id + '.ui-datepicker-calendar th,';					// Überschrift der Woche und der Tage im Datepicker

    rules += wrapper_id + 'input';
    rules += '{color: '+ themeColors.fcContent +'!important;}';


    //***** TEXTFARBE HEADER *****//
    rules += wrapper_id + '.ui-widget-header span,';
    rules += wrapper_id + '.ui-widget-header a'; 							// Für Link Leistungsbeschreibung in slidingForm-Rechnern
    rules += '{color: '+ themeColors.fcHeader +'!important;}';


    //***** TEXTFARBE STATE-DEFAULT *****//
 	rules += wrapper_id + '.ui-state-default span,';						// z.B. default Buttons
  	rules += wrapper_id + '.ui-widget-content .ui-state-default,'; 			// z.B Farbe der Tage im Kalender
   	rules += wrapper_id + '.ui-myresult .ui-mytooltip .ui-state-default .ui-mytooltip-titlebar-title';	 // Für Title der fixOnClick-Tooltips im Resultat (für Charts)
    rules += '{color: '+ themeColors.fcDefault +'!important;}';


    //***** TEXTFARBE STATE-HOVER *****//
 	rules += wrapper_id + '.ui-state-hover span,';							// z.B. gehoverte Buttons
 	rules += wrapper_id + '.ui-widget-content .ui-state-hover'; 			// z.B gehovertes Datums im Kalender
    rules += '{color: '+ themeColors.fcHover +'!important;}';


    //***** TEXTFARBE STATE-ACTIVE *****//
 	rules += wrapper_id + '.ui-state-active span,';							// z.B. aktive Buttons
 	rules += wrapper_id + '.ui-widget-content .ui-state-active'; 			// z.B Farbe des ausgewählten Datums im Kalender
    rules += '{color: '+ themeColors.fcActive +'!important;}';


    //***** TEXTFARBE STATE-HGHLIGHT *****//
 	rules += wrapper_id + '.ui-state-highlight span,';						// z.B. gehighlightete Buttons (Weiß nicht, wo das derzeit vorkommt)
 	rules += wrapper_id + '.ui-widget-content .ui-state-highlight'; 		// z.B heutiges Datums im Kalender
    rules += '{color: '+ themeColors.fcHighlight +'!important;}';


    //***** TEXTFARBE STATE-ERROR *****//
    rules += wrapper_id + '.ui-state-error';
    rules += '{color: '+ themeColors.fcError +'!important;}';




  	//****** AUSNAHME: DELTA *****//
  	// Delta hat Ausnahme-CSS, so dass Button immer weiß beschriftet sind, active Selection aber dunkel bleibt...
	if (themeColors.name == "delta")
	{
		rules += wrapper_id + '.ui-button.ui-state-default span,';
		rules += wrapper_id + '.ui-myresult .ui-datepicker-calendar .ui-state-default';		// Datepicker-Tage im Ergebnis (Arbeitstage-Rechner) immer weiß
		rules += '{color: #ffffff!important;}';

		rules += wrapper_id + '.slidingformNav a.ui-state-active';							// in slidingForm-Navigation: aktiver Nav-Button schwarz beschriftet
		rules += '{color: #000000!important;}';
	}



	return rules;
}
		var rules = getAdditionalColorRules(themes[data.name], settings.styleid);
		currentStyle.next('style').remove();
		currentStyle.after($("<style title=\'"+settings.styleclass+"\'type=\'text/css\'><!--"+ rules +"--></style>"));
	}



})( jQuery );
